#ifndef CHECKPATTERN_HH
#define CHECKPATTERN_HH
#include "element.hh"

/*
 * CheckPattern(len)
 *
 * Check the packets generated by SendPattern(n)
 */

class CheckPattern : public Element {
  
  unsigned _len;
  
 public:
  
  CheckPattern();
  ~CheckPattern();
  
  const char *class_name() const		{ return "CheckPattern"; }
  Processing default_processing() const	{ return AGNOSTIC; }
  
  CheckPattern *clone() const { return new CheckPattern; }
  int configure(const String &, ErrorHandler *);
  
  Packet *simple_action(Packet *);
  
};

#endif
