/*
 * Copyright (c) 1999 University of Utah and the Flux Group.
 * All rights reserved.
 * 
 * This file is part of the Flux OSKit.  The OSKit is free software, also known
 * as "open source;" you can redistribute it and/or modify it under the terms
 * of the GNU General Public License (GPL), version 2, as published by the Free
 * Software Foundation (FSF).  To explore alternate licensing terms, contact
 * the University of Utah at csl-dist@cs.utah.edu or +1-801-585-3271.
 * 
 * The OSKit is distributed in the hope that it will be useful, but WITHOUT ANY
 * WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE.  See the GPL for more details.  You should have
 * received a copy of the GPL along with the OSKit; see the file COPYING.  If
 * not, write to the FSF, 59 Temple Place #330, Boston, MA 02111-1307, USA.
 */

/*
 * Startup code that is called out of click.c when built as a traditional
 * Click router kernel. Not really used much at this point now that we go
 * through the oskit_clicker COM interface.
 */

#include <oskit/startup.h>
#include <oskit/clientos.h>

void
do_oskit_stuff(void)
{
	static int done;

	if (done)
		return;

	oskit_clientos_init();
	start_clock();
	start_cq_console();
#ifdef OSKIT_UNIX
	start_fs_native(".");
#else
	start_fs_bmod();
#endif
	start_net_devices();
}
