#ifndef TIMER_HH
#define TIMER_HH
#include "glue.hh"
class Element;

/*
 * Implement timers in terms of OSKit clock.
 */
extern "C" {
#include <oskit/dev/clock.h>
#include <oskit/dev/timer.h>
#include <oskit/com/listener.h>
}

typedef void (*TimerHook)(unsigned long);

class Timer {
	oskit_clock_t		*_clock; 
  	oskit_timer_t		*_timer;
	TimerHook		_hook;
	unsigned long		_data;
	bool			_scheduled;

	Timer(const Timer &);
	Timer &operator=(const Timer &);

	static void element_timer(unsigned long);
	static int  handler(struct oskit_iunknown *clock, void *arg);
	
public:
	Timer(TimerHook, unsigned long);
	Timer(Element *);
	~Timer();
  
	bool scheduled() const		{ return _scheduled; }
	
	void schedule_after_ms(int);
	void unschedule();
};
#endif
